﻿using System;
using System.Collections.Generic;
using System.Text;
using PaintDotNet;
using PaintDotNet.Data;
using System.IO;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace FileTypeVbp
{
    public class VbpFileType : FileType
    {
        public VbpFileType()
            : base("Vantage Bitmap",
                FileTypeFlags.SupportsLoading | FileTypeFlags.SupportsSaving,
                new String[] { ".vbp" })
        {
        }

        protected override Document OnLoad(Stream input)
        {
            try
            {
                VbpFile vbp = new VbpFile();
                Bitmap b = vbp.ReadBitmap(input);

                return Document.FromImage(b);
            }
            catch
            {
                MessageBox.Show("Problem Importing File");

                Bitmap b = new Bitmap(500, 500);

                return Document.FromImage(b);
            }
        }

        protected override void OnSave(Document input, Stream output, SaveConfigToken token, 
            Surface scratchSurface, ProgressEventHandler callback)
        {
            RenderArgs ra = new RenderArgs(new Surface(input.Size));
            input.Render(ra);

            if ((input.Width != 160) || (input.Height != 120))
            {
                MessageBox.Show("Warning! The Vantage Receiver only accepted a dimension 160x120.");
            }
            VbpFile vbp = new VbpFile();
            vbp.WriteBitmap(ra.Bitmap, output);
        }
    }

    public class VbpFileTypeFactory : IFileTypeFactory
    {
        public FileType[] GetFileTypeInstances()
        {
            return new FileType[] { new VbpFileType() };
        }
    }
}
